<!DOCTYPE html>
<html lang="en-us">

  <head>
  <link href="http://gmpg.org/xfn/11" rel="profile">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta http-equiv="content-type" content="text/html; charset=utf-8">

  <!-- Enable responsiveness on mobile devices-->
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1">

  <title>
    
      Quickly ediff files from dired &middot; (or emacs
    
  </title>

  <link rel="canonical" href="index.html" />

  <!-- CSS -->
  <link rel="stylesheet" href="../../../../public/css/poole.css">
  <link rel="stylesheet" href="../../../../public/css/syntax.css">
  <link rel="stylesheet" href="../../../../public/css/lanyon.css">
  <link rel="stylesheet" href="../../../../public/css/octicons.css">
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=PT+Serif:400,400italic,700%7CPT+Sans:400">

  <!-- Scripts -->
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>

  <!-- Icons -->
  <link rel="apple-touch-icon-precomposed" sizes="144x144" href="https://oremacs.com/public/apple-touch-icon-precomposed.png">
  <link rel="shortcut icon" href="../../../../public/favicon.ico">

  <!-- RSS -->
  <link rel="alternate" type="application/rss+xml" title="RSS" href="https://oremacs.com/atom.xml">
</head>


  <body class="layout-reverse theme-base-08">

    <!-- Target for toggling the sidebar `.sidebar-checkbox` is for regular
     styles, `#sidebar-checkbox` for behavior. -->
<input type="checkbox" class="sidebar-checkbox" id="sidebar-checkbox">

<!-- Toggleable sidebar -->
<div class="sidebar" id="sidebar">
  <!-- <div class="sidebar-item"> -->
  <!--   <p>unused</p> -->
  <!-- </div> -->

  <nav class="sidebar-nav">
    <a class="sidebar-nav-item" href="https://oremacs.com/">Home</a>

    

    
    
      
        
      
    
      
        
      
    
      
        
          <a class="sidebar-nav-item" href="https://oremacs.com/about/">About</a>
        
      
    
      
        
          <a class="sidebar-nav-item" href="https://oremacs.com/archive/">Archive</a>
        
      
    
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    
      
        
      
    

    <div id="github" class="sidebar-nav-item">
      <button type="button"
              class="btn btn-info"
              data-toggle="collapse"
              data-target="#github-projects">
        <span class="octicon octicon-mark-github"></span> My Emacs Projects
      </button>
      <div id="github-projects" class="collapse">
        <ul style="margin-bottom:0em;">
          <li>
            <a href="https://github.com/abo-abo/lispy">lispy</a>
            <p>vi-like Paredit</p>
          </li>
          <li>
            <a href="https://github.com/abo-abo/worf">worf</a>
            <p>vi-like bindings for org-mode</p>
          </li>
          <li>
            <a href="https://github.com/abo-abo/ace-window">ace-window</a>
            <p>switch windows with <code>ace-jump-mode</code></p>
          </li>
          <li>
            <a href="https://github.com/abo-abo/ace-link">ace-link</a>
            <p>follow links with <code>ace-jump-mode</code></p>
          </li>
          <li>
            <a href="https://github.com/abo-abo/function-args">function-args</a>
            <p>enhance <code>CEDET</code> for C++</p>
          </li>
          <li>
            <a href="https://github.com/abo-abo/helm-make">helm-make</a>
            <p>select a Makefile target with <code>helm</code></p>
          </li>
          <li>
            <a href="https://github.com/abo-abo/make-it-so">make-it-so</a>
            <p>transform files with Makefile recipes</p>
          </li>
          <li>
            <a href="https://github.com/abo-abo/org-download">org-download</a>
            <p>drag-and-drop images to <code>org-mode</code></p>
          </li>
          <li>
            <a href="https://github.com/abo-abo?tab=repositories">
              <span class="octicon octicon-octoface"></span>
              and more
            </a>
          </li>
        </ul>
      </div>
    </div>
  </nav>
  <script async defer id="github-bjs" src="https://buttons.github.io/buttons.js"></script>

  <div class="sidebar-item">
    <p>
      <a rel="license" href="https://creativecommons.org/licenses/by-sa/4.0/">
        <img alt="Creative Commons License"
             style="border-width:0;opacity: 0.3;"
             src="https://licensebuttons.net/l/by-sa/4.0/88x31.png"/>
      </a>
    </p>
  </div>
</div>


    <!-- Wrap is the content to shift when toggling the sidebar. We wrap the
         content to avoid any CSS collisions with our real content. -->
    <div class="wrap">
      <div class="masthead">
        <div class="container">
          <h3 class="masthead-title">
            <a href="https://oremacs.com/" title="Home">(or emacs</a>
            <small>irrelevant)</small>
          </h3>
        </div>
      </div>

      <div class="container content">
        <div class="post">
  <h1 class="post-title">Quickly ediff files from dired</h1>
  <span class="post-date">18 Mar 2017</span>
  <blockquote>
<p>ediff.el --- a comprehensive visual interface to diff &amp; patch</p>
</blockquote>

<p>I wrote about
ediff <a href="../../../../2015/01/17/setting-up-ediff/index.html">years ago</a>.
Today, I&#39;ll just reference a useful ediff snippet
from <a href="https://github.com/abo-abo/oremacs">my config</a> that I&#39;ve added
some time ago and refined only recently.</p>

<p>The premise is quite simple: press <kbd>e</kbd> in <code>dired-mode</code> to
immediately ediff two marked files, no questions asked:</p>
<div class="highlight"><pre><code class="language-elisp" data-lang="elisp"><span></span><span class="p">(</span><span class="nf">define-key</span> <span class="nv">dired-mode-map</span> <span class="s">&quot;e&quot;</span> <span class="ss">&#39;ora-ediff-files</span><span class="p">)</span>
</code></pre></div>
<p>And here&#39;s the code, with a few bells and whistles:</p>
<div class="highlight"><pre><code class="language-elisp" data-lang="elisp"><span></span><span class="c1">;; -*- lexical-binding: t -*-</span>
<span class="p">(</span><span class="nb">defun</span> <span class="nv">ora-ediff-files</span> <span class="p">()</span>
  <span class="p">(</span><span class="k">interactive</span><span class="p">)</span>
  <span class="p">(</span><span class="k">let</span> <span class="p">((</span><span class="nv">files</span> <span class="p">(</span><span class="nv">dired-get-marked-files</span><span class="p">))</span>
        <span class="p">(</span><span class="nv">wnd</span> <span class="p">(</span><span class="nf">current-window-configuration</span><span class="p">)))</span>
    <span class="p">(</span><span class="k">if</span> <span class="p">(</span><span class="nf">&lt;=</span> <span class="p">(</span><span class="nf">length</span> <span class="nv">files</span><span class="p">)</span> <span class="mi">2</span><span class="p">)</span>
        <span class="p">(</span><span class="k">let</span> <span class="p">((</span><span class="nv">file1</span> <span class="p">(</span><span class="nf">car</span> <span class="nv">files</span><span class="p">))</span>
              <span class="p">(</span><span class="nv">file2</span> <span class="p">(</span><span class="k">if</span> <span class="p">(</span><span class="nf">cdr</span> <span class="nv">files</span><span class="p">)</span>
                         <span class="p">(</span><span class="nv">cadr</span> <span class="nv">files</span><span class="p">)</span>
                       <span class="p">(</span><span class="nv">read-file-name</span>
                        <span class="s">&quot;file: &quot;</span>
                        <span class="p">(</span><span class="nv">dired-dwim-target-directory</span><span class="p">)))))</span>
          <span class="p">(</span><span class="k">if</span> <span class="p">(</span><span class="nf">file-newer-than-file-p</span> <span class="nv">file1</span> <span class="nv">file2</span><span class="p">)</span>
              <span class="p">(</span><span class="nv">ediff-files</span> <span class="nv">file2</span> <span class="nv">file1</span><span class="p">)</span>
            <span class="p">(</span><span class="nv">ediff-files</span> <span class="nv">file1</span> <span class="nv">file2</span><span class="p">))</span>
          <span class="p">(</span><span class="nv">add-hook</span> <span class="ss">&#39;ediff-after-quit-hook-internal</span>
                    <span class="p">(</span><span class="nb">lambda</span> <span class="p">()</span>
                      <span class="p">(</span><span class="k">setq</span> <span class="nv">ediff-after-quit-hook-internal</span> <span class="no">nil</span><span class="p">)</span>
                      <span class="p">(</span><span class="nf">set-window-configuration</span> <span class="nv">wnd</span><span class="p">))))</span>
      <span class="p">(</span><span class="ne">error</span> <span class="s">&quot;no more than 2 files should be marked&quot;</span><span class="p">))))</span>
</code></pre></div>
<p>Some notes on how the extra code adds convenience:</p>

<ol>
<li><p>In case no files are marked, the file at point is used as the first
file, and <code>read-file-name</code> is used for the second file.  Since I
have the magic <code>(setq dired-dwim-target t)</code> in my config, in case a
second <code>dired</code> buffer is open, <code>dired-dwim-target-directory</code> will
offer it as the starting directory during completion. Very useful
to compare two files in two different directories.</p></li>
<li><p>Depending on the order of the arguments to <code>ediff-files</code>, the
changes will appear either as added or removed;
<code>file-newer-than-file-p</code> tries to put the arguments in a logical
order by looking at the files&#39; last change times.</p></li>
<li><p><code>ediff-after-quit-hook-internal</code> is used to restore the previous
  window configuration after I quit <code>ediff</code> with <kbd>q</kbd>.</p></li>
</ol>

<p>That&#39;s about it. Hopefully, it&#39;s useful. Happy hacking.</p>

</div>

<div class="twitter-share">
  <a href="https://twitter.com/share"
     class="twitter-share-button"
     data-via="_abo_abo"
     data-dnt="true">
    Tweet
  </a>
</div>

<div id="disqus_thread"></div>
<script type="text/javascript">
  var disqus_shortname = 'oremacs'; // required: replace example with your forum shortname

  /* * * DON'T EDIT BELOW THIS LINE * * */
  (function() {
  var dsq = document.createElement('script'); dsq.type = 'text/javascript'; dsq.async = true;
  dsq.src = '//' + disqus_shortname + '.disqus.com/embed.js';
  (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(dsq);
  })();
</script>

<script>
  !function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');
</script>
<noscript>
  Please enable JavaScript to view the
  <a href="http://disqus.com/?ref_noscript">comments powered by Disqus.</a>
</noscript>

      </div>
    </div>

    <label for="sidebar-checkbox" class="sidebar-toggle"></label>

    <script>
      (function(document) {
        var toggle = document.querySelector('.sidebar-toggle');
        var sidebar = document.querySelector('#sidebar');
        var checkbox = document.querySelector('#sidebar-checkbox');

        document.addEventListener('click', function(e) {
          var target = e.target;

          if(!checkbox.checked ||
             sidebar.contains(target) ||
             (target === checkbox || target === toggle)) return;

          checkbox.checked = false;
        }, false);
      })(document);
    </script>
  </body>
</html>
